﻿package com.everydayflash.futbolowo {
	
	import five3D.display.Scene3D;
	import five3D.geom.Point3D;
	import gs.TweenLite;
	import fl.motion.easing.Elastic;
	
	import flash.events.Event;
	import flash.display.MovieClip;
	import flash.display.Sprite;

	public class LogoAnimation extends Sprite {
		
		[Embed(source="../../../../assets/futbolowo_assets.swf", symbol="FinalAnimation")]
		private var FinalAnim:Class;
		private var anim:MovieClip;
		
		private var main:Main;
		
		private var scene:Scene3D;
		
		public function LogoAnimation(main:Main) {
			this.main = main;
			anim = new FinalAnim() as MovieClip;
			anim.x = 375;
			anim.y = 63;
			addChild(anim);
			addEventListener(Event.ENTER_FRAME, control);
		}
		
		private function control(e:Event):void {
			if (anim.currentFrame == anim.totalFrames) {
				removeEventListener(Event.ENTER_FRAME, control);
				anim.stop();
				main.restart();
			} else if (anim.currentFrame == 62) {
				lastCopy();
			} else if (anim.currentFrame == 112) {
				lastRemove();
			}
		}
		
		public function lastCopy():void {
			scene = new Scene3D();
			scene.x = 375;
			scene.y = 63;
			scene.viewDistance = 500;
			addChild(scene);
			
			var actors:Actors = main.actors;
			
			actors.joinUs.setPosition(actors.join_bp);
			actors.joinUs.setRotation(actors.join_br);
			scene.addChild(actors.joinUs);
			
			var e2:Point3D = actors.join_ep;
			var r2:Point3D = actors.join_er;
			TweenLite.to(actors.joinUs, 1, { 
				x:e2.x, y:e2.y, z:e2.z, rotationX:r2.x, rotationY:r2.y, rotationZ:r2.z, 
				ease:Elastic.easeOut
			} );
		}

		private function lastRemove():void {
			removeChild(scene);
		}
	}
}