﻿package com.everydayflash.futbolowo {

	import five3D.display.Sprite3D;
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.display.LoaderInfo;
	
	import five3D.display.DynamicText3D;
	import five3D.display.Scene3D;

	[SWF(backgroundColor = "#558a20", frameRate = "30", width = "750", height = "120")]
	
	public class Main extends Sprite {

		private var scene:Scene3D;
		
		public var actors:Actors;
		private var splay:Screenplay;
		
		private var fanim:LogoAnimation;
		
		private var url:String;
		private var holder:Sprite;
		private var linker:Sprite;
		
		public function Main() {
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			stage.quality = StageQuality.BEST;
			
			if (LoaderInfo(this.root.loaderInfo).parameters["clickTag"] != null) {
				url = LoaderInfo(this.root.loaderInfo).parameters["clickTag"];
			} else {
				url = "http://www.futbolowo.pl"
			}
			
			
			holder = new Sprite();
			holder.mouseEnabled = false;
			//holder.filters = [new BlurFilter(4,4,1)];
			addChild(holder);

			actors = new Actors();
			setupActors();
			
			linker = new Sprite();
			linker.addEventListener(MouseEvent.MOUSE_UP, click);
			
			linker.graphics.beginFill(Data.DARK_GREEN, 1);
			linker.graphics.drawRect(0, 0, 750, 1);
			linker.graphics.drawRect(0, 124, 750, 1);
			
			linker.graphics.drawRect(0, 1, 1, 123);
			linker.graphics.drawRect(749, 1, 1, 123);
			linker.graphics.endFill();
			
			linker.graphics.beginFill(Data.WHITE, 0);
			linker.graphics.drawRect(1, 1, 748, 123);
			linker.graphics.endFill();

			linker.buttonMode = true;
			addChild(linker);
			
			run();
		}
		
		public function click(me:MouseEvent):void {
			navigateToURL(new URLRequest(url));
		}
		
		private function run():void {
			actors.stadium = new Stadium(actors);
			setupScene();
			splay = new Screenplay(actors, scene, this);
			splay.openCurtain();
		}
		
		private function setupScene():void {
			scene = new Scene3D();
			scene.x = 375;
			scene.y = 63;
			scene.viewDistance = 500;
			holder.addChild(scene);
		}
		
		private function setupActors():void {
			actors.yourClub = Data.get3DText(Data.yourClub);
			actors.doesNot = Data.get3DText(Data.doesNot);
			actors.website = Data.get3DText(Data.website);
			actors.whyWait = Data.get3DText(Data.whyWait);
			actors.createOne = Data.get3DText(Data.createOne);
			actors.forFree = Data.get3DText(Data.forFree);
			actors.joinUs = Data.get3DText(Data.joinUs);
		}
		
		public function startLogo(e:Event = null):void {
			fanim = new LogoAnimation(this);
			holder.addChild(fanim);
		}

		public function finish3d(e:Event = null):void {
			scene.removeChild(actors.stadium);
			holder.removeChild(scene);
		}

		public function restart():void {
			holder.removeChild(fanim);
			run();
		}
	}
}
















