﻿package com.everydayflash.futbolowo {
	
	import five3D.display.Scene3D;
	import flash.events.Event;
	import gs.TweenLite;
	import fl.motion.easing.Elastic;
	import fl.motion.easing.Linear;
	import fl.motion.easing.Sine;
	import five3D.display.Sprite3D;
	import five3D.geom.Point3D;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.system.fscommand;

	public class Screenplay {
		
		private var actors:Actors;
		private var scene:Scene3D;
		private var main:Main;
		
		public function Screenplay(actors:Actors, scene:Scene3D, main:Main) {
			this.actors = actors;
			this.scene = scene;
			this.main = main;
		}
		
		public function openCurtain():void {
			inYourClub();
		}
		
		private function inYourClub():void {
			scene.addChild(actors.yourClub);
			actors.yourClub.setPosition(actors.yourClub_bp);
			actors.yourClub.setRotation(actors.yourClub_br);
			
			var e:Point3D = actors.yourClub_ep;
			var r:Point3D = actors.yourClub_er;
			TweenLite.to(actors.yourClub, .5, {
				x:e.x, y:e.y, z:e.z, rotationX:r.x, rotationY:r.y, rotationZ:r.z, 
				ease:Elastic.easeOut, onComplete:inDoesNot } );
		}
		
		private function inDoesNot():void {
			scene.addChild(actors.doesNot);
			actors.doesNot.setPosition(actors.doesNot_bp);
			actors.doesNot.setRotation(actors.doesNot_br);
			
			var e:Point3D = actors.doesNot_ep;
			var r:Point3D = actors.doesNot_er;
			TweenLite.to(actors.doesNot, .5, { 
				x:e.x, y:e.y, z:e.z, rotationX:r.x, rotationY:r.y, rotationZ:r.z, 
				ease:Elastic.easeOut, onComplete:inWebsite } );
		}
		
		private function inWebsite():void {
			scene.addChild(actors.website);
			actors.website.setPosition(actors.website_bp);
			actors.website.setRotation(actors.website_br);
			
			var e:Point3D = actors.website_ep;
			var r:Point3D = actors.website_er;
			TweenLite.to(actors.website, .8, { 
				x:e.x, y:e.y, z:e.z, rotationX:r.x, rotationY:r.y, rotationZ:r.z, 
				ease:Elastic.easeOut, onComplete:pauseOne
			} );
		}
		
		private function pauseOne():void {
			var t:Timer = new Timer(500, 1);
			t.addEventListener(TimerEvent.TIMER_COMPLETE, prepareStadium);
			t.start();
		}
		
		private function prepareStadium(te:TimerEvent):void {
			var ac:Sprite3D = actors.yourClub;
			TweenLite.to(ac, .8, { 
				x:ac.x + 100, y:ac.y - 160, rotationZ:ac.rotationZ + 10,
				ease:Linear.easeIn
			} );
			
			var de:Sprite3D = actors.doesNot;
			TweenLite.to(de, .8, { 
				x:de.x + 100, y:de.y - 160, rotationZ:de.rotationZ + 10,
				ease:Linear.easeIn, onComplete:firstPartOut
			} );
			
			var we:Sprite3D = actors.website;
			TweenLite.to(we, .8, { 
				x:we.x + 100, y:we.y - 160, rotationZ:we.rotationZ + 10,
				ease:Linear.easeIn
			} );
			
			inStadium();
		}
		
		private function firstPartOut():void {
			scene.removeChild(actors.yourClub);
			scene.removeChild(actors.doesNot);
			scene.removeChild(actors.website);
		}
		
		private function inStadium():void {
			actors.stadium.visible = false;
			actors.stadium.setPosition(actors.stadium_bp);
			actors.stadium.setRotation(actors.stadium_br);
			
			var e:Point3D = actors.stadium_ep;
			var r:Point3D = actors.stadium_er;

			TweenLite.to(actors.stadium, 1.2, { 
				x:e.x, y:e.y, z:e.z, rotationX:r.x, rotationZ:r.z, 
				ease:Sine.easeOut, onComplete:pauseTwo
			} );
			
			actors.stadium.visible = true;
			scene.addChild(actors.stadium);
		}
		
		private function pauseTwo():void {
			actors.stadium.animateGround();
			
			var t:Timer = new Timer(1600, 1);
			t.addEventListener(TimerEvent.TIMER_COMPLETE, inGoal);
			t.start();
		}
		
		private function inGoal(te:TimerEvent):void {
			actors.stadium.createFlags();
			
			var e:Point3D = actors.stadium_gp;
			var r:Point3D = actors.stadium_gr;
			
			TweenLite.to(actors.stadium, .6, { 
				x:e.x, y:e.y, z:e.z, rotationX:r.x, rotationZ:r.z, 
				ease:Sine.easeInOut, onComplete:pauseThree
			} );
		}
		
		private function pauseThree():void {
			var t:Timer = new Timer(1500, 1);
			t.addEventListener(TimerEvent.TIMER_COMPLETE, inFinal);
			t.start();
		}
		
		private function inFinal(te:TimerEvent):void {
			
			var e:Point3D = actors.stadium_fp;
			var r:Point3D = actors.stadium_fr;
			
			actors.stadium.cleanUp();
			
			TweenLite.to(actors.stadium, 1.7, { 
				x:e.x, z:e.z, rotationX:r.x, rotationZ:r.z, y:e.y, rotationY:r.y, 
				ease:Sine.easeOut, onComplete:main.finish3d
			} );
			
			var t:Timer = new Timer(1300, 1);
			t.addEventListener(TimerEvent.TIMER_COMPLETE, main.startLogo);
			t.start();
		}

		public static function xtrace(msg:Object):void {
			fscommand("trace", msg.toString());
        }
	}
}














